<template>
  <v-app>
    <div class="container-fluid p-0">
      <div class="row p-0">
        <div class="col-md-3 px-0 py-0">
          <div id="nav">
            <div id="infos-site" class="pt-3 pb-3">
              <router-link to="/">
                <div class="bg-infos-site">
                  <h3 id="title-site" class="pl-3 pt-3">
                    <i id="title-icon" class="fas fa-book-open pr-3"></i>SHAREBOOK
                  </h3>
                  <small id="slogan" class="pl-3">A la porte de la culture</small>
                </div>
              </router-link>
            </div>

            <v-divider></v-divider>

            <p id="about-nav" class="text-center pt-3">
              <i id="infos-icon" class="fas fa-info-circle"></i>
              <router-link to="/a-propos">A propos</router-link>
            </p>

            <autocomplete
              class="col-md-12"
              :search="search"
              placeholder="Rechercher un article"
              aria-label="Search an article"
              :get-result-value="getResultValuePosts"
              @submit="handleSubmitPost"
            ></autocomplete>

            <ul class="pt-5 pb-2">
              <li class="pb-3 pl-4">
                <i id="articles-icon" class="far fa-newspaper pr-3"></i>
                <router-link to="/tous-les-articles">Tous les articles</router-link>
              </li>
              <li class="pl-4 pb-3">
                <i id="categories-icon" class="fas fa-list"></i>
                <span id="category-title">Catégories</span>
                <AllCategoriesList
                  v-for="(category, c) in categories"
                  :key="`${c}-${category}`"
                  :category="category"
                  class="text-center"
                />
              </li>
              <li id="socials-network" class="pl-4 mt-5">
                <div class="text-center">
                  <a href="https://instagram.com/melectrice" target="_blank">
                    <i class="fab fa-instagram pr-2"></i>
                  </a>
                  <a href="https://gitlab.com/mel.gvn" target="_blank">
                    <i class="fab fa-gitlab pr-2"></i>
                  </a>
                  <a href="https://www.linkedin.com/in/melissa-galvan-5344a1177/">
                    <i class="fab fa-linkedin"></i>
                  </a>
                </div>
              </li>
            </ul>
          </div>
        </div>
        <div class="col-md-9 px-5">
          <router-view />
        </div>
      </div>
    </div>
    <!-- </div> -->
  </v-app>
</template>

<script>
import Autocomplete from "@trevoreyre/autocomplete-vue";
import "@trevoreyre/autocomplete-vue/dist/style.css";
import CategoryService from "./services/CategoryServices";
import PostService from "./services/PostServices";
import AllCategoriesList from "./components/AllCategoriesList";

export default {
  name: "App",

  components: {
    Autocomplete,
    AllCategoriesList
  },
  data: () => ({
    drawer: true,
    categories: [],
    posts: []
  }),
  mounted() {
    const service = new CategoryService();
    service
      .findAll()
      .then(data => {
        this.categories = data;
      })
      .catch(() => this.$router.push("/"));

    const postService = new PostService();
    postService
      .findAll()
      .then(data => {
        this.posts = data;
      })
      .catch(() => this.$router.push("/"));
  },
  methods: {
    search(input) {
      if (input.length < 1) {
        return [];
      }
      return this.posts.filter(post => {
        return post.title.toLowerCase().includes(input.toLowerCase());
      });
    },
    getResultValuePosts(result) {
      return result.title;
    },
    handleSubmitPost(result) {
      window.open(`http://localhost:8080/article/${result.id}`, "_self");
    }
  }
};
</script>

<style lang="scss">
$green: #60ca60d8;
$green-dark: #449644;
$black: #000000;

#app {
  font-size: 15px;
  letter-spacing: 1px;
}
a {
  outline: none;
  text-decoration: none;
}
#nav {
  padding: 0 10px 0 10px;
  color: $black;
  position: -webkit-sticky;
  position: sticky;
  top: 0;

  #infos-site {
    background-image: url("./assets/books.jpg");
    background-position-y: -250px;

    a {
      color: $black;
    }
    .bg-infos-site {
      background-color: $green;
    }

    #title-site {
      text-transform: uppercase;
      letter-spacing: 3px;
      font-weight: 400;
    }
  }

  #slogan {
    font-style: italic;
    text-transform: uppercase;
    letter-spacing: 2px;
    font-size: 10px;
  }

  .autocomplete-input {
    height: 40px;
  }

  i:not(#title-icon) {
    font-size: 20px;
  }

  ul {
    list-style: none;
    padding: 0;

    #categories-icon {
      padding-right: 13px;
      padding-left: 2px;
    }

    #category-title {
      font-weight: 600;
    }

    li a {
      text-decoration: none;
      color: $green-dark;
    }

    #socials-network {
      p {
        margin-bottom: 5px;
      }

      i {
        font-size: 24px;
      }
    }
  }

  #about-nav {
    a {
      color: $green-dark;
    }

    #infos-icon {
      padding-right: 7px;
    }
  }
}

h1 {
  font-size: 20px;
}

h2 {
  font-size: 18px;
}

h1,
h2 {
  font-weight: 400;
  color: $green-dark;
  text-transform: uppercase;
  letter-spacing: 3px;
}
</style>
